/*_############################################################################
  _## 
  _##  xmibquery.cpp  
  _##
  _##  SNMP++v3.2.10
  _##  -----------------------------------------------
  _##  Copyright (c) 2001-2004 Jochen Katz, Frank Fock
  _##
  _##  This software is based on SNMP++2.6 from Hewlett Packard:
  _##  
  _##    Copyright (c) 1996
  _##    Hewlett-Packard Company
  _##  
  _##  ATTENTION: USE OF THIS SOFTWARE IS SUBJECT TO THE FOLLOWING TERMS.
  _##  Permission to use, copy, modify, distribute and/or sell this software 
  _##  and/or its documentation is hereby granted without fee. User agrees 
  _##  to display the above copyright notice and this license notice in all 
  _##  copies of the software and any documentation of the software. User 
  _##  agrees to assume all liability for the use of the software; 
  _##  Hewlett-Packard and Jochen Katz make no representations about the 
  _##  suitability of this software for any purpose. It is provided 
  _##  "AS-IS" without warranty of any kind, either express or implied. User 
  _##  hereby grants a royalty-free license to any and all derivatives based
  _##  upon this software code base. 
  _##  
  _##  Stuttgart, Germany, Tue Jan 13 01:13:13 CET 2004 
  _##  
  _##########################################################################*/
/*

  Copyright (c) 1996
  Hewlett-Packard Company

  ATTENTION: USE OF THIS SOFTWARE IS SUBJECT TO THE FOLLOWING TERMS.
  Permission to use, copy, modify, distribute and/or sell this software
  and/or its documentation is hereby granted without fee. User agrees
  to display the above copyright notice and this license notice in all
  copies of the software and any documentation of the software. User
  agrees to assume all liability for the use of the software; Hewlett-Packard
  makes no representations about the suitability of this software for any
  purpose. It is provided "AS-IS without warranty of any kind,either express
  or implied. User hereby grants a royalty-free license to any and all
  derivatives based upon this software code base.

*/
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

#ifdef XOPEN_CATALOG
#include <locale.h>
#endif

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xlib.h>

#include <Xm/Xm.h>

#include <snmp_pp.h>
#include <eventlist.h>
#include "v3.h"

XtAppContext	UxAppContext;
Widget		UxTopLevel;
Widget		FormHandle;
Display		*UxDisplay;
int		UxScreen;
Snmp            *the_Session;

  /*----------------------------------------------------------------*/
  /* Function prototype for initializer.  This is required, because */
  /* there is no way for a general interface to determine what app  */
  /* context to use without explicit statement by the user.         */
  /*----------------------------------------------------------------*/

void snmp_initialize(XtAppContext app_context){
  int status;
  snmp_version version=version3; 
  status = SNMPX11Initialize(app_context);

  the_Session = new Snmp(status);
  if (status){
    fprintf(stderr, "Failed to create Snmp Session:\n  %s\n", 
	    the_Session->error_msg(status));
    delete the_Session;
    exit(1);
  }
   //---------[ init SnmpV3 ]--------------------------------------------
   if (version == version3) {
     char *filename = "snmpv3_boot_counter";
     unsigned int snmpEngineBoots = 0;
     OctetStr engineId("xmibquery");

     status = getBootCounter(filename, engineId, snmpEngineBoots);
     if ((status != SNMPv3_OK) && (status < SNMPv3_FILEOPEN_ERROR))
       cerr << "Error loading snmpEngineBoots counter: " << status << endl;

     snmpEngineBoots++;

     status = saveBootCounter(filename, engineId, snmpEngineBoots);
     if (status != SNMPv3_OK)
       cerr << "Error saving snmpEngineBoots counter: " << status << endl;


     v3MP *v3_MP = new v3MP(engineId, snmpEngineBoots, status);

     USM *usm = v3_MP->get_usm();

     // users at UCD
     usm->add_usm_user("SHADESUser",
		       SNMPv3_usmHMACSHAAuthProtocol, SNMPv3_usmDESPrivProtocol,
		       "The UCD Demo Password", "The UCD Demo Password");

     usm->add_usm_user("SHAMD5User",
		       SNMPv3_usmHMACMD5AuthProtocol, SNMPv3_usmDESPrivProtocol,
		       "The UCD Demo Password", "The UCD Demo Password");

     usm->add_usm_user("noAuthUser",
		       SNMPv3_usmHMACMD5AuthProtocol, SNMPv3_usmDESPrivProtocol,
		       "Password", "Password");

     // testusers
     usm->add_usm_user("unsecureUser",
		       SNMPv3_usmNoAuthProtocol, SNMPv3_usmNoPrivProtocol, 
		       "", "");

     usm->add_usm_user("MD5",
		       SNMPv3_usmHMACMD5AuthProtocol, SNMPv3_usmNoPrivProtocol,
		       "MD5UserAuthPassword", "");

     usm->add_usm_user("SHA",
		       SNMPv3_usmHMACSHAAuthProtocol, SNMPv3_usmNoPrivProtocol,
		       "SHAUserAuthPassword", "");

     usm->add_usm_user("MD5DES",
		       SNMPv3_usmHMACMD5AuthProtocol, SNMPv3_usmDESPrivProtocol,
		       "MD5DESUserAuthPassword", "MD5DESUserPrivPassword");

     usm->add_usm_user("SHADES",
		       SNMPv3_usmHMACSHAAuthProtocol, SNMPv3_usmDESPrivProtocol,
		       "SHADESUserAuthPassword", "SHADESUserPrivPassword");

     usm->add_usm_user("MD5IDEA",
		       SNMPv3_usmHMACMD5AuthProtocol, SNMPv3_usmIDEAPrivProtocol,
		       "MD5IDEAUserAuthPassword", "MD5IDEAUserPrivPassword");

     usm->add_usm_user("SHAIDEA",
		       SNMPv3_usmHMACSHAAuthProtocol, SNMPv3_usmIDEAPrivProtocol,
		       "SHAIDEAUserAuthPassword", "SHAIDEAUserPrivPassword");
   }
}

Widget create_form1(Widget);

int main( int argc, char *argv[])
{
  	Widget mainIface;

	/*---------------------
	 * Initialize program
	 *--------------------*/

#ifdef XOPEN_CATALOG
	setlocale(LC_ALL,"");
	if (XSupportsLocale()) {
		XtSetLanguageProc(NULL,(XtLanguageProc)NULL,NULL);
	}
#endif

  	UxTopLevel = XtAppInitialize(&UxAppContext, "xquery",
				     NULL, 0, &argc, argv, NULL, NULL, 0);

	snmp_initialize(UxAppContext);

	UxDisplay = XtDisplay(UxTopLevel);
	UxScreen = XDefaultScreen(UxDisplay);

	mainIface = create_form1(UxTopLevel);
	FormHandle = mainIface;

	XtPopup(mainIface, XtGrabNone);

	/*-----------------------
	 * Enter the event loop 
	 *----------------------*/
  	XtAppMainLoop (UxAppContext);
}
